import es, gamethread, random, popuplib, playerlib, cfglib, services, usermsg, langlib, weaponlib
# Thanks SuperDave and jeff91 for dict help and DanielB

# Public # Basiclly Public Varibles (used For game-monitor)
info = es.AddonInfo()
info.name     = "Deathmatch"
info.version  = "2.0"
info.url      = "None"
info.basename = "sic_deathmatch"
info.author   = "sicman_adrian"
es.ServerVar('sic_dm', info.version, 'Red Vs Blue Deathmatch').makepublic()
#Public#

# Cfglib Very useful (http://python.eventscripts.com/pages/Cfglib)
config = cfglib.AddonCFG(es.getAddonPath("deathmatch") + "/deathmatch.cfg")
config.text("********************")
config.text(" Guns Menu Settings And Respawn")
config.text("********************")
menu_enable   = config.cvar("menu_enable",   1, "This enables and Disables weapon menu")
primaryweapons = config.cvar("primary_names",     "M4A1 AK47 AWP Scout SG552 Galil Famas SG550 AUG m249 G3SG1 UMP45 MP5NAVY M3 xm1014 TMP Mac10 P90", "Priamry menu list")
secondary = config.cvar("pistol_names",   "Usp Glock Deagle P228 Elite FiveSeven", "Pistol menu list")
givekevlar   = config.cvar("givekevlar",   1, "Option to give players Kevlars")
deathtype = config.cvar("deathtype",      1, "Death Type: 1 = no dissovle, 2 =  Energy Effect ,3 = Heavy Electrical Effect, 4 = Light Electrical  Effect,5 = Core Effect,6 = Random")
deathtime   = config.cvar("deathtime",   3, "How long bodie Stays")
deadtime   = config.cvar("deathtime",   3, "How long till they respawn")
roundendenable   = config.cvar("roundend_enable",   1, "Enable Round end")
config.text("*************************")
config.text("Spawn Protection Settings")
config.text("*************************")
spawn_protection   = config.cvar("spawn_protection",   1, "Enable or Disable Spawn Protection")
protection_time   = config.cvar("protection_time",   2.5, "Time Protected")
protection_health   = config.cvar("protection_health",   1124, " Protection Health ,Recommend 1124")
protection_alpha   = config.cvar("protection_alpha",   100, " Alpha When spawned ,100 half invisible, Default 255")
protection_god   = config.cvar("protection_god",   0, "This disables protection health instead uses est_god")
config.text("*************************")
config.text("       GamesModes        ")
config.text("*************************")
gamemodes_enable = config.cvar("gamemodes_enable",   1, "Enable/Disable gamemodes")
gamemodes_redvsblue = config.cvar("gamemodes_redvsblue",   0, "Red Vs Blue Gamemode,So far Red vs blue Is just Blue and Red Master Chief skins for both teams")
gamemodes_headshotonly = config.cvar("gamemodes_headshotonly",   0, "Head Shot Only Gamemode")
config.text("*************************")
config.text("         Extras          ")
config.text("*************************")
noblock   = config.cvar("noblock",   1, "Enable and Disables noblock Allowing people to walk throught other players")
spec   = config.cvar("spec",   1, "Allows players to go spec using !spec in chat")
givehe   = config.cvar("givehe",   1, "Gives Players HE Grenades When They Spawn")
givesmoke   = config.cvar("givesmoke",   1, "Gives Players Smoke Grenades When They Spawn")
giveflash   = config.cvar("giveflash",   1, "Gives Players Flashbangs When They Spawn")
unlimitednade   = config.cvar("unlimitednade",   1, "Gives Players Unlimited Nades")

config.write()
#

# Do not Touch (Sets Dicts
weapon_dict = {}
protection_dict = {}
weapon_ammo_dict = {'weapon_m4a1':90,'weapon_ak47':90,'weapon_awp':30,'weapon_Scout':90,'weapon_sg552':90, 'weapon_galil':90,'weapon_famas':90,'weapon_sg550':90,'weapon_aug':90,'weapon_m249':200,'weapon_g3sg1':90, 'weapon_ump45':100,'weapon_mp5navy':120,'weapon_m3':32,'weapon_xm1014':32,'weapon_tmp':120,'weapon_mac10':120, 'weapon_p90':100,'weapon_usp':100,'weapon_glock':100,'weapon_deagle':35,'weapon_p228':52,'weapon_elite':120,
'weapon_fiveseven':100}

text = None 

#  Wraps es.msg + Text
def msg(texty):
    es.msg('#multi', texty)

def tell(userid, texty):
    es.tell(userid, '#multi', '#green[Deathmatch]#lightgreen ' + texty)

def spawnmsg(texty):
    es.msg('#multi', '#green[Deathmatch Spawn Protection]#lightgreen ' + texty)

def spawntell(userid, texty):
    es.tell(userid, '#multi', '#green[Deathmatch Spawn Protection]#lightgreen ' + texty)

def load():
    global mainmenu, primarymenu, pistolmenu, text
    config.execute()
    text = langlib.Strings(es.getAddonPath("deathmatch") + "/strings.ini")
    msg(text("load"))
    es.set('eventscripts_noisy', 1)
    es.flags('remove', 'cheat', 'endround')
    roundtime = es.ServerVar('mp_roundtime') 
    mainmenu = popuplib.create('mainmenu')
    mainmenu.addline('Deathmatch')
    mainmenu.addline('----------------------')
    mainmenu.addline('->1. New weapons')
    mainmenu.addline('->2. Same weapons')
    mainmenu.addline('->3. Same weapons every time')
    mainmenu.addline('->4. Random weapons')
    mainmenu.addline('->5. Random weapons every time')
    mainmenu.addline('----------------------')
    mainmenu.menuselect = mainmenu_menuselect
    primarymenu = popuplib.easymenu('primarymenu', '_popup_choice', primarymenu_menuselect)
    primarymenu.settitle('Primary weapons')
    for c in str(primaryweapons).split(): primarymenu.addoption(c, c)
    pistolmenu = popuplib.easymenu('pistolmenu', '_popup_choice', pistolmenu_menuselect)
    pistolmenu.settitle('Pistols')
    for c in str(secondary).split(): pistolmenu.addoption(c, c)
    es.addons.registerClientCommandFilter(superdaves_client_filter)
    setup_auth()
    downloadsound()
    if spawn_protection == 1:
        spawnmsg('Loaded')
    if gamemodes_enable == 1:
        gamemodes()
    adminmenu = popuplib.create('adminmenu')
    adminmenu.addline('Deathmatch Admin')
    adminmenu.addline('--------------------')
    adminmenu.addline('->1. Spawn Protection')
    adminmenu.addline('->2. Guns menu')
    adminmenu.addline('->3. Gamemodes')
    adminmenu.addline('->4. Dissolver')
    adminmenu.addline('->5. Extras')
    adminmenu.addline('->0. Exit')
    adminmenu.addline('--------------------')
    adminmenu.menuselect = adminmenu_menuselect

    protection = popuplib.create('protection')
    protection.addline('Deathmatch Spawn Protection')
    protection.addline('--------------------')
    protection.addline('->1. Enable Protection')
    protection.addline('->2. Disable Protection')
    protection.addline('->3. God Protection Mode')
    protection.addline('->4. Health Protection Mode')
    protection.addline('->8. Back')
    protection.submenu(8,'adminmenu')
    protection.addline('->0. Exit')
    protection.addline('--------------------')
    protection.menuselect = protection_menuselect

    gunmenu = popuplib.create('gunmenu')
    gunmenu.addline('Deathmatch Gun Menu')
    gunmenu.addline('--------------------')
    gunmenu.addline('->1. Enable Gun Menu')
    gunmenu.addline('->2. Disable Gun Menu')
    gunmenu.addline('->8. Back')
    gunmenu.submenu(8,'adminmenu')
    gunmenu.addline('->0. Exit')
    gunmenu.addline('--------------------')
    gunmenu.menuselect = gunmenu_menuselect

    extra = popuplib.create('extra')
    extra.addline('Deathmatch Extra Menu')
    extra.addline('--------------------')
    extra.addline('->1. Enable Noblock')
    extra.addline('->2. Disable Noblock')
    extra.addline('->8. Back')
    extra.submenu(8,'adminmenu')
    extra.addline('->0. Exit')
    extra.addline('--------------------')
    extra.menuselect = extra_menuselect

    gamemodesmenu = popuplib.create('gamemodesmenu')
    gamemodesmenu.addline('Deathmatch Gamemodes')
    gamemodesmenu.addline('-----------------------')
    gamemodesmenu.addline('->1. Load Red vs Blue')
    gamemodesmenu.addline('->2. Unload Red vs Blue')
    gamemodesmenu.addline('->3. Load Head Shot Only')
    gamemodesmenu.addline('->4. Unload Head Shot Only')
    gamemodesmenu.addline('->8. Back')
    gamemodesmenu.submenu(8,'adminmenu')
    gamemodesmenu.addline('->0. Exit')
    gamemodesmenu.addline('------------------------')
    gamemodesmenu.menuselect = gamemodesmenu_menuselect
    
    deathtypemenu = popuplib.create('deathtypemenu')
    deathtypemenu.addline('Deathmatch Dissolver')
    deathtypemenu.addline('-----------------------')
    deathtypemenu.addline('->1. No Dissovle')
    deathtypemenu.addline('->2. Energy Effect')
    deathtypemenu.addline('->3. Heavy Electrical Effect')
    deathtypemenu.addline('->4. Light Electrical')
    deathtypemenu.addline('->5. Core Effect')
    deathtypemenu.addline('->6. Random')
    deathtypemenu.addline('->8. Back')
    deathtypemenu.submenu(8,'adminmenu')
    deathtypemenu.addline('->0. Exit')
    deathtypemenu.addline('------------------------')
    deathtypemenu.menuselect = deathtypemenu_menuselect

def es_map_start(ev):
    downloadsound()

def downloadsound():
    es.stringtable('downloadables','sound/sicdm/menuselect.mp3')

def adminmenu_menuselect (userid, choice, popupid):
    if choice == 1:
        popuplib.send('protection', userid)
        es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 2:
          popuplib.send('gunmenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 3:
          popuplib.send('gamemodesmenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 4:
          popuplib.send('deathtypemenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 5:
          popuplib.send('extra', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')

def protection_menuselect (userid, choice, popupid):
    global spawn_protection
    global protection_god
    if choice == 1:
        spawn_protection = 1
        msg(text("spawn load"))
        popuplib.send('protection', userid)
        es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 2:
          spawn_protection = 0
          msg(text("spawn unload"))
          popuplib.send('protection', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 3:
          protection_god = 1
          msg(text("spawn god"))
          popuplib.send('protection', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 4:
          protection_god = 0
          msg(text("spawn health"))
          popuplib.send('protection', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')

def gunmenu_menuselect (userid, choice, popupid):
    global menu_enable
    if choice == 1:
        menu_enable = 1
        msg(text("gun menu enabled"))
        popuplib.send('gunmenu', userid)
        es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 2:
          menu_enable = 0
          msg(text("gun menu disable"))
          popuplib.send('gunmenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')

def gamemodesmenu_menuselect (userid, choice, popupid):
    if choice == 1:
        es.load('deathmatch/gamemodes/rvb')
        msg(text("rvb enabled"))
        popuplib.send('gamemodesmenu', userid)
        es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 2:
          es.unload('deathmatch/gamemodes/rvb')
          msg(text("rvb disabled"))
          popuplib.send('gamemodesmenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 3:
          es.load('deathmatch/gamemodes/headshotonly')
          msg(text("headshot enable"))
          popuplib.send('gamemodesmenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 4:
          es.unload('deathmatch/gamemodes/headshotonly')
          msg(text("headshot disable"))
          popuplib.send('gamemodesmenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')

def extra_menuselect (userid, choice, popupid):
    global noblock
    if choice == 1:
        noblock = 1
        msg(text("noblock enable"))
        popuplib.send('extra', userid)
        es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 2:
          noblock = 0
          msg(text("noblock disable"))
          popuplib.send('extra', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')

def deathtypemenu_menuselect (userid, choice, popupid):
    global deathtype
    if choice == 1:
        deathtype = 1
        popuplib.send('deathtypemenu', userid)
        es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 2:
          deathtype = 2
          popuplib.send('deathtypemenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 3:
          deathtype = 3
          popuplib.send('deathtypemenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 4:
          deathtype = 4
          popuplib.send('deathtypemenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 5:
          deathtype = 5
          popuplib.send('deathtypemenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 6:
          deathtype = 6
          popuplib.send('deathtypemenu', userid)
          es.cexec(userid, 'play sicdm/menuselect.mp3')

def unload():
    popuplib.delete('mainmenu')
    popuplib.delete('pistolmenu')
    popuplib.delete('primarymenu')
    msg(text("unload"))
    es.unload('deathmatch/gamemodes/rvb')
    es.unload('deathmatch/gamemodes/headshotonly')
    es.addons.unregisterClientCommandFilter(superdaves_client_filter)

def gamemodes():
    if gamemodes_redvsblue == 1:
        es.load('deathmatch/gamemodes/rvb')
        msg(text("rvb enabled"))
    if gamemodes_headshotonly == 1:
        es.load('deathmatch/gamemodes/headshotonly')
        msg(text("headshot enabled"))

def mainmenu_menuselect (userid, choice, popupid):
    if choice == 1:
        weapon_dict[userid]['menu'] = 0
        popuplib.send('pistolmenu', userid)
        es.cexec(userid, 'play sicdm/menuselect.mp3')
    elif choice == 2:
        stripplayer(userid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['primary']))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['pistol']))
        es.cexec(userid, 'play sicdm/menuselect.mp3')
        grenades(userid)
    elif choice == 3:
        weapon_dict[userid]['menu'] = 1
        stripplayer(userid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['primary']))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['pistol']))
        es.cexec(userid, 'play sicdm/menuselect.mp3')
        grenades(userid)
    elif choice == 4:
        stripplayer(userid)
        random_primary = random.choice(str(primaryweapons).split())
        random_pistol = random.choice(str(secondary).split())
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))
        es.cexec(userid, 'play sicdm/menuselect.mp3')
        grenades(userid)
    elif choice == 5:
        weapon_dict[userid]['menu'] = 2
        stripplayer(userid)
        random_primary = random.choice(str(primaryweapons).split())
        random_pistol = random.choice(str(secondary).split())
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))
        es.cexec(userid, 'play sicdm/menuselect.mp3')
        grenades(userid)

def primarymenu_menuselect (userid, choice, popupid):
    weapon_dict[userid]['primary'] = choice
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, choice))
    es.cexec(userid, 'play sicdm/menuselect.mp3')
    grenades(userid)

def pistolmenu_menuselect (userid, choice, popupid):
    weapon_dict[userid]['pistol'] = choice
    stripplayer(userid)
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, choice))
    popuplib.send('primarymenu', userid)
    es.cexec(userid, 'play sicdm/menuselect.mp3')


def player_spawn(event_var):
    global weapon_dict, protection_dict
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    bot = myPlayer.attributes['isbot']
    if userid not in weapon_dict:
        weapon_dict[userid] = {'primary':None,'Secondary':None,'menu':0}
    if givekevlar:
        if alive == 0:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s item_assaultsuit' % userid)
    if userid not in protection_dict:
        protection_dict[userid] = {'invincible':0}
    if weapon_dict[userid]['menu'] == 0:
        if alive == 0:
            if menu_enable == 1:
                popuplib.send('mainmenu', userid)
    elif weapon_dict[userid]['menu'] == 1:
          if alive == 0:
              stripplayer(userid)
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['primary']))
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['pistol']))
    elif weapon_dict[userid]['menu'] == 2:
          if alive == 0:
              stripplayer(userid)
              random_primary = random.choice(str(primaryweapons).split())
              random_pistol = random.choice(str(secondary).split())
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))
    if bot:
        if alive == 0:
            if menu_enable == 1:
                stripplayer(userid)
                random_primary = random.choice(str(primaryweapons).split())
                random_pistol = random.choice(str(secondary).split())
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))
    if spawn_protection == 1:
        if protection_god == 0:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', protection_health)
            myPlayer.set("color", (255, 255, 255, protection_alpha))
            protection_dict[userid]['invincible'] = 1
            gamethread.delayed(protection_time, removeprotection, (userid))
        else:
            es.server.queuecmd('est_god %s 1'%userid)
            myPlayer.set("color", (255, 255, 255, protection_alpha))
            protection_dict[userid]['invincible'] = 1
            gamethread.delayed(protection_time, removeprotection, (userid))
    if noblock == 1:
        es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)
    if not alive:
        grenades(userid)


def flashbang_detonate(event_var):
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    if alive == 0:
        if unlimitednade == 1:
            gamethread.delayed(0.1, es.server.cmd, 'es_xgive %s weapon_flashbang' % userid)

def smokegrenade_detonate(event_var):
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    if alive == 0:
        if unlimitednade == 1:
            gamethread.delayed(0.1, es.server.cmd, 'es_xgive %s weapon_smokegrenade' % userid)

def hegrenade_detonate(event_var):
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    if alive == 0:
        if unlimitednade == 1:
            gamethread.delayed(0.1, es.server.cmd, 'es_xgive %s weapon_hegrenade' % userid)

def player_activate(event_var):
    global protection_dict
    userid = int(event_var['userid'])
    if userid not in protection_dict:
        protection_dict[userid] = {'invincible':None}

def player_hurt(event_var):
    userid = int(event_var['userid'])
    if protection_dict[userid]['invincible'] == 1:
        if protection_god == 0:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', protection_health)

def weapon_reload(event_var):
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    weapon = myPlayer.attributes['weapon']
    if weapon in weapon_ammo_dict:
        myPlayer.set('ammo',(weapon,weapon_ammo_dict[weapon]))

def player_death(event_var):
    global mode
    userid = int(event_var['userid'])
    for index in weaponlib.getIndexList('#all'):
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
                es.server.queuecmd('es_xremove %s' % index)
    if deathtype == 6:
        mode = random.randint(1,5)
    else:
        mode = deathtype

    if mode == 1:
          es.delayed(deathtime, "es_fire %s cs_ragdoll kill" % userid)
          es.delayed(deadtime, 'est_spawn %s 1'%userid)
    else:
          es.delayed(deathtime, 'es_give %s env_entity_dissolver' % userid)
          es.delayed(deathtime, 'es_fire %s env_entity_dissolver AddOutput "target cs_ragdoll"' % userid)
          es.delayed(deathtime, 'es_fire %s env_entity_dissolver AddOutput "magnitude 1"' % userid)
          es.delayed(deathtime, 'es_fire %s env_entity_dissolver AddOutput "dissolvetype %s"' % (userid,mode-2))
          es.delayed(deathtime, 'es_fire %s env_entity_dissolver Dissolve' % userid)
          es.delayed(deadtime, 'est_spawn %s 1'%userid)

def player_team(event_var):
    userid = int(event_var['userid'])
    if es.exists('userid', event_var['userid']): 
        if event_var['es_userteam'] >= 2:
            es.delayed(3, 'est_spawn %s 0'%userid)

def round_start(event_var):
    kill()
    gamethread.delayed(10, usermsg.hudhint, ('#all', text('hudhint')))
    if roundend_enable:
        gamethread.cancelDelayed('round_end')
        gamethread.delayedname(roundtime * 60., 'round_end', es.server.queuecmd, 'endround')

def kill():
    userid = es.getuserid()
    if userid:
        es.server.queuecmd('es_xfire %s func_hostage_rescue kill'% userid)
        es.server.queuecmd('es_xfire %s hostage_entity kill'% userid)
        es.server.queuecmd('es_xfire %s func_bomb_target kill'% userid)
        es.server.queuecmd('es_xfire %s func_buyzone kill'% userid)

def stripplayer(userid):
    es.server.queuecmd('es_xfire %s player_weaponstrip kill' % userid)
    es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_knife' % userid)

def es_player_chat(event_var):
    userid = int(event_var['userid'])
    text = event_var['text']
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    team = myPlayer.attributes['teamid']
    if text == 'guns':
        if alive == 0:
            if team >= 1:
                if menu_enable == 1:
                    popuplib.send('mainmenu', userid)
    if text == '!spec':
        if spec:
            es.changeteam(userid,  '1')
    if text == '!sicadmin':
        if isAuthed(userid):
            popuplib.send('adminmenu', userid)
        else:
            es.tell(userid, '#multi','#greenYou are not authorized to run this command')

def superdaves_client_filter(userid, args):
    if args[0].lower() == 'drop':
      for index in weaponlib.getIndexList('#all'):
          if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
                 es.server.queuecmd('es_xremove %s' % index)
    return True 


def removeprotection(userid):
    myPlayer = playerlib.getPlayer(userid)
    if protection_god == 1:
        myPlayer.set("color", (255, 255, 255, 255))
        es.server.queuecmd('est_god %s 0'%userid)
        protection_dict[userid]['invincible'] = 0
    elif protection_god == 0:
          myPlayer.set("color", (255, 255, 255, 255))
          es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 100)
          protection_dict[userid]['invincible'] = 0

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('deathmatch_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'deathmatch_admin')
    else:
        isAuthed = lambda x: False

def grenades(userid):
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    if givehe == 1:
        if alive == 0:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_hegrenade' % userid)
    if givesmoke == 1:
        if alive == 0:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_smokegrenade' % userid)
    if giveflash == 1:
        if alive == 0:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % userid)

def player_disconnect(event_var):
    userid = int(event_var['userid'])
    if es.exists('userid', userid):
        del weapon_dict[userid]
        del protection_dict[userid]